// *** SciGui main function
// *** by G. Casonato - Marzo 2007

function SciGui ()
  // editor per costruire GUI

  // costruzione della parte grafica della finestra principale

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // *** chiusura file aperti ***
  file('close',file());

  // crea finestra principale
  fx = 100;
  fy = 100;
  fw = 400;
  fh = 1;
  hfig = figure(1, 'position', [fx fy fw fh]);
  disp(hfig);

  // aggiunge oggetti menu

  // menu bar
  hmenuFile = uimenu(hfig, 'label', 'File');
  hmenuFileNew = uimenu(hmenuFile, 'label', 'New...', 'callback', "cbFileNew");
  hmenuFileLoad = uimenu(hmenuFile, 'label', 'Load...', 'callback', "cbFileLoad");
  hmenuFileSave = uimenu(hmenuFile, 'label', 'Save...', 'callback', "cbFileSave");
  hmenuFileQuit = uimenu(hmenuFile, 'label', 'Quit', 'callback', "cbFileQuit");

  hmenuEdit = uimenu(hfig, 'label', 'Edit');
  hmenuEditFigure = uimenu(hmenuEdit, 'label', 'Figure...', 'callback', "cbEditFigure");
  hmenuEditButton = uimenu(hmenuEdit, 'label', 'Button...', 'callback', "cbEditButton");
  hmenuEditTextField = uimenu(hmenuEdit, 'label', 'TextField...', 'callback', "cbEditTextField");
  hmenuEditLabel = uimenu(hmenuEdit, 'label', 'Label...', 'callback', "cbEditLabel");
  hmenuEditListBox = uimenu(hmenuEdit, 'label', 'ListBox...', 'callback', "cbEditListBox");
  hmenuEditCheckBox = uimenu(hmenuEdit, 'label', 'CheckBox...', 'callback', "cbEditCheckBox");
   // ...

  hmenuAdd = uimenu(hfig, 'label', 'Add');
  hmenuAddButton = uimenu(hmenuAdd, 'label', 'Button...', 'callback', "cbAddButton");
  hmenuAddTextField = uimenu(hmenuAdd, 'label', 'TextField...', 'callback', "cbAddTextField");
  hmenuAddLabel = uimenu(hmenuAdd, 'label', 'Label...', 'callback', "cbAddLabel");
  hmenuAddListBox = uimenu(hmenuAdd, 'label', 'ListBox...', 'callback', "cbAddListBox");
  hmenuAddCheckBox = uimenu(hmenuAdd, 'label', 'CheckBox...', 'callback', "cbAddCheckBox");
  //...

  hmenuTools = uimenu(hfig, 'label', 'Tools');
  hmenuToolsGrid = uimenu(hmenuTools, 'label', 'Toggle Grid', 'callback', "cbToolsGrid");

  hmenuHelp = uimenu(hfig, 'label', '?');
  hmenuHelpAbout = uimenu(hmenuHelp, 'label', 'About', 'callback', "cbHelpAbout");

  // crea finestra di lavoro
  resetGlobals();  
  hfig_wk = editFigure ('new', hfig, 2);
  disp(hfig_wk);

endfunction



/////////////////////////////////////////////////
////////////       CALLBACKS         ////////////
/////////////////////////////////////////////////

///// FILE //////

function cbFileNew()
  disp('File New...');
  
  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // reset finestra di lavoro e lista oggetti
//  close(hfig_wk);
  resetGlobals();
  hfig_wk = editFigure ('edit', hfig, 2);
  
  disp('done.');
endfunction

function cbFileLoad()
  disp('File Load...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // carica dati da file SCIGUI
  fname = getFileName ('load');
  fd = mopen(fname, 'r');

  // reset finestra di lavoro
  close(hfig_wk);
  resetGlobals();
  hfig_wk = editFigure ('new', hfig, 2);

  // legge prima riga
  str = mgetl(fd, 1);
  while meof(fd) == 0
    // processa riga letta
    if strindex(str, '// MAIN GUI') == 1 then
      // dati finestra - leggi e aggiorna posizione
      loadFigure(fd, hfig_wk);
      
    elseif strindex(str, '// BUTTON') == 1 then
      // dati pulsante - crea con stessi parametri
      hobj = loadButton(fd, hfig_wk);
      hobjs = [hobjs; hobj];

    elseif strindex(str, '// TEXTFIELD') == 1 then
      // dati textfield - crea con stessi parametri
      hobj = loadTextField(fd, hfig_wk);
      hobjs = [hobjs; hobj];

    elseif strindex(str, '// LABEL') == 1 then
      // dati label - crea con stessi parametri
      hobj = loadLabel(fd, hfig_wk);
      hobjs = [hobjs; hobj];

    elseif strindex(str, '// LISTBOX') == 1 then
      // dati listbox - crea con stessi parametri
      hobj = loadListBox(fd, hfig_wk);
      hobjs = [hobjs; hobj];

    elseif strindex(str, '// CHECKBOX') == 1 then
      // dati checkbox - crea con stessi parametri
      hobj = loadCheckBox(fd, hfig_wk);
      hobjs = [hobjs; hobj];

//...altri oggetti...
      
      
    elseif strindex(str, '// CALLBACK') == 1 then
      // dati callback - memorizza in lista dedicata
      hcb = loadCallback(fd);
      hcblist($+1) = hcb;

    elseif strindex(str, '// INIT-PRE-BEGIN') == 1 then
      // dati inizializzazioni preliminari - memorizza in lista dedicata
      hpreinit = loadPreInit(fd);

    elseif strindex(str, '// INIT-POST-BEGIN') == 1 then
      // dati inizializzazioni finali - memorizza in lista dedicata
      hpostinit = loadPostInit(fd);

    elseif strindex(str, '// AUX-FUN-BEGIN') == 1 then
      // dati funzioni ausiliarie - memorizza in lista dedicata
      hauxfun = loadAuxFun(fd);
      
    end

    // legge prossima riga
    str = mgetl(fd, 1);
  end

  mclose(fd);
  disp('done..');

endfunction

function cbFileSave()
  disp('File Save...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // salva dati in file SCIGUI
  mfun = 'myGui';
  fname = getFileName ('save');
  fd = mopen(fname, 'w');

//  mfprintf(fd, '// %s\n', fname);
  mfprintf(fd, '// *** SCIGUI V %s AUTO-GENERATED FILE ***\n', SCIGUI_VERSION);
  mfprintf(fd, '// *** DO NOT EDIT BUT SPECIFIED ENTRY-POINTS ***\n\n\n');
  mfprintf(fd, '// MAIN FUNCTION\n');
  mfprintf(fd, 'function %s ()\n\n', mfun);

  // pre-init settings
  savePreInit (fd, hpreinit);

  // main GUI
  saveFigure (fd, hfig_wk);
  
  // oggetti grafici
  if size(hobjs, 1) > 0 then
    mfprintf(fd, '// Create objects\n');
  end
  for i = 1 : size(hobjs, 1)
    objType = get(hobjs(i), 'style');
    select objType
      case 'pushbutton' then 
        saveButton (fd, hobjs(i));
        
      case 'edit' then 
        saveTextField (fd, hobjs(i));
        
      case 'text' then 
        saveLabel (fd, hobjs(i));

      case 'listbox' then
        saveListBox (fd, hobjs(i));

      case 'checkbox' then
        saveCheckBox (fd, hobjs(i));

//     case 'radiobutton' then instructions2,
//     case 'slider' then instructions2,
//     case 'frame' then instructions2,
//     case 'popupmenu' then instructions2,
//     [else instructions],
    end
  end
  
  // post-init settings
  savePostInit (fd, hpostinit);
  
  mfprintf(fd, 'endfunction\n\n\n');
  
  // callbacks (solo per push button)
  for i = 1 : size(hcblist)
    saveCallback (fd, hcblist(i));
  end  

  // auxiliary functions
  saveAuxFun (fd, hauxfun);  

  mclose(fd);
  disp('Save done.');
endfunction

function cbFileQuit()
  disp('File Quit...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  disp(hobjs);
  close(hfig_wk);
  close(hfig); 
  hobjs = [];
  
  disp('SciGui closed.');
endfunction


///// EDIT //////

function cbEditFigure()
  disp('Edit Figure...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // apri finestra con valori attuali
  editFigure('edit', hfig, hfig_wk);
endfunction

function cbEditButton()
  disp('Edit Button...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject('pushbutton');
  
  // apri finestra con valori attuali
  if hobj > 0 then
    editButton('edit', hfig_wk, hobj);
  end
endfunction

function cbEditTextField()
  disp('Edit TextField...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject('edit');
  
  // apri finestra con valori attuali
  if hobj > 0 then
    editTextField('edit', hfig_wk, hobj);
  end
endfunction

function cbEditLabel()
  disp('Edit Label...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject('text');
  
  // apri finestra con valori attuali
  if hobj > 0 then
    editLabel('edit', hfig_wk, hobj);
  end
endfunction

function cbEditListBox()
  disp('Edit ListBox...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject('listbox');
  
  // apri finestra con valori attuali
  if hobj > 0 then
    editListBox('edit', hfig_wk, hobj);
  end
endfunction

function cbEditCheckBox()
  disp('Edit CheckBox...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject('checkbox');
  
  // apri finestra con valori attuali
  if hobj > 0 then
    editCheckBox('edit', hfig_wk, hobj);
  end
endfunction


///// ADD //////

function cbAddButton()
  disp('Add Button...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');
  
  // crea oggetto
  id = size(hobjs, 1) + 1;
  hbut = editButton('new', hfig_wk, id);
  hobjs = [hobjs; hbut];
  
  // crea corpo CB e aggiunge alla lista
  objcb = get(hbut, 'callback');
  hcb = list();
  hcb($+1) = 'function ' + objcb;
  hcb($+1) = '  disp(''...CB <' + objcb + '> called...'');';
  hcb($+1) = 'endfunction';
  hcblist($+1) = hcb;
endfunction

function cbAddTextField()
  disp('Add TextField...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // crea oggetto
  id = size(hobjs, 1) + 1;
  hobj = editTextField('new', hfig_wk, id);
  hobjs = [hobjs; hobj];
endfunction

function cbAddLabel()
  disp('Add Label...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // crea oggetto
  id = size(hobjs, 1) + 1;
  hobj = editLabel('new', hfig_wk, id);
  hobjs = [hobjs; hobj];
endfunction

function cbAddListBox()
  disp('Add ListBox...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // crea oggetto
  id = size(hobjs, 1) + 1;
  hobj = editListBox('new', hfig_wk, id);
  hobjs = [hobjs; hobj];
endfunction

function cbAddCheckBox()
  disp('Add CheckBox...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // crea oggetto
  id = size(hobjs, 1) + 1;
  hobj = editCheckBox('new', hfig_wk, id);
  hobjs = [hobjs; hobj];
endfunction


///// TOOLS //////

function cbToolsGrid()
  disp('Tools Grid...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // mostra/rimuovi griglia
  showGrid (hfig_wk);
endfunction



///// HELP //////

function cbHelpAbout()
  disp('Help About...');

  x_message(['SciGui v. '+SCIGUI_VERSION, 'G. Casonato - 2007']);
endfunction



///// MISC //////

function resetGlobals ()
  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // reset var. globali
  hfig_wk = 0;
  hobjs = [];
  hcblist = list();

  hpreinit = list();
  hpostinit = list();
  hauxfun = list();
endfunction

function fname = getFileName (hmode)
  if hmode == 'load'
    fname = tk_getfile ('*.sci', Title='Select SCIGUI file');
  else
    fname = xgetfile ('*.sci', title='Select SCIGUI file');
  end
endfunction

function hobj = selectObject(objstyle)
  // costruisce matrice oggetti:
  // colonna 1: string
  // colonna 2: handler

  objmat = [];
  for i = 1 : size(hobjs, 1)
    if get(hobjs(i), 'style') == objstyle then
      str = get(hobjs(i), 'string');
      objmat = [objmat; [str string(hobjs(i))]];
    end
  end
  
  // richiede scelta
  if size(objmat, 1) > 0 then
    sel = x_choose(objmat(:, 1), ['Select object to edit']);
    if sel > 0 then
      hobj = evstr(objmat(sel, 2));
    else
      hobj = 0;
    end
  end
endfunction

