// *** SciGui push button object handling
// *** by G. Casonato - Marzo 2007

function hobj = loadButton(fd, hfig_wk)
  disp('Load Button...');
  
  // legge dati da file
  str = mgetl(fd, 1); // uicontrol
  str = mgetl(fd, 1); // tag
  pos = strindex(str, '''tag'', ''');
  str1 = strsplit(str, pos+7);
  str2 = sscanf(str1(2), '%s');
  str3 = strsplit(str2, length(str2)-2);
  objtag = str3(1);    

  str = mgetl(fd, 1); // string
  pos = strindex(str, '''string'', ''');
  str1 = strsplit(str, pos+10);
  str2 = sscanf(str1(2), '%s');
  str3 = strsplit(str2, length(str2)-2);
  objstr = str3(1);   

  str = mgetl(fd, 1); // callback
  pos = strindex(str, '''callback'', ''');
  str1 = strsplit(str, pos+12);
  str2 = sscanf(str1(2), '%s');
  str3 = strsplit(str2, length(str2)-2);
  objcb = str3(1);  

  str = mgetl(fd, 1); // position
  pos = strindex(str, '[');
  str1 = strsplit(str, pos);
  [px, py, wd, hg] = sscanf(str1(2), '%d %d %d %d]');

  // crea oggetto
  hobj = uicontrol(hfig_wk, 'style', 'pushbutton', ...
    'tag', objtag, ...
    'string', objstr, ...
    'callback', objcb, ...
    'position', [px py wd hg]);
endfunction

function saveButton (fd, hobj)
  disp('Save Button...');

  pos = get(hobj, 'position');
  pos = evstr(pos);
  tag = get(hobj, 'tag');
  str = get(hobj, 'string');
  cb = get(hobj, 'callback');
  mfprintf(fd, '// BUTTON: %s\n', str);
  mfprintf(fd, 'hobj = uicontrol(hfig, ''style'', ''pushbutton'', ...\n');
  mfprintf(fd, '  ''tag'', ''%s'', ...\n', tag);
  mfprintf(fd, '  ''string'', ''%s'', ...\n', str);
  mfprintf(fd, '  ''callback'', ''%s'', ...\n', cb);
  mfprintf(fd, '  ''position'', [%d %d %d %d]);\n\n', pos(1), pos(2), pos(3), pos(4)); 
//  mfprintf(fd, 'hobjs = [hobjs; hbut];\n\n');
endfunction

function hobj = editButton (hmode, hfig_wk, hobj)
  disp('Edit Button...');
  
  // hmode definisce modalit:
  // - new:  crea nuova oggetto con ID <hobj>
  // - edit: modifica oggetto esistente <hobj>

  // legge posizione/nome
  if hmode == 'edit' then
    // edit: legge valori correnti
    objpos = get(hobj, 'position');
    objstr = get(hobj, 'string');
  else
    // new: imposta valori di default
    objpos = [100 100 50 20];
    objtag = 'Button'+string(hobj);
    objstr = objtag;
    objcb = 'cbButton'+string(hobj);
  end  
  
  lbl = ['position (x, y): '; 'size (width, height): '; 'label: '];
  def = [string(objpos(1))+' '+string(objpos(2)); ...
         string(objpos(3))+' '+string(objpos(4)); ...
         objstr];
  objdata = x_mdialog('enter object data', lbl, def);
  objpos = evstr(objdata(1 : 2));
  objstr = objdata(3);

  px = objpos(1,1);
  py = objpos(1,2);
  wd = objpos(2,1);
  hg = objpos(2,2);

  // applica parametri
  if hmode == 'edit' then
    // edit: modifica parametri oggetto   
    set(hobj, 'position', [px py wd hg]);
    set(hobj, 'string', objstr);
  else
    // new: aggiunge oggetto nella posizione specificata
    hobj = uicontrol(hfig_wk, 'style', 'pushbutton', ...
      'tag', objtag, ...
      'string', string(objstr), ...
      'callback', objcb, ...
      'position', [px py wd hg]);
  end
   
endfunction


