// *** SciGui callback, pre-post init calls and aux functions management
// *** by G. Casonato - Marzo 2007

function hcb = loadCallback (fd)
  disp('Load Callback...');

  // legge dati da file
  hcb = list();
  str = mgetl(fd, 1);
  while strindex(str, 'endfunction') ~= 1
    // aggiunge linea alla lista
    hcb($+1) = str;
    
    // legge riga successiva
    str = mgetl(fd, 1);
  end

  // aggiunge ultima linea
  hcb($+1) = str;
endfunction

function saveCallback (fd, hcb)
  disp('Save Callback...');
  
  // CB list contiene tutte le righe della funzione CB
  // (prima ed ultima incluse)
  mfprintf(fd, '// CALLBACK\n');
  for i = 1 : size(hcb)
    mfprintf(fd, '%s\n', hcb(i));
  end
  mfprintf(fd, '\n');
endfunction


//////////////////////////////////////////////////////////////////////////////////////////////////

function hlist = loadPreInit (fd)
  disp('Load Pre-Init...');
  
  // legge dati da file
  hlist = list();
  str = mgetl(fd, 1);
  while strindex(str, '// INIT-PRE-END') ~= 1
    // aggiunge linea alla lista
    hlist($+1) = str;
    
    // legge riga successiva
    str = mgetl(fd, 1);
  end
endfunction

function savePreInit (fd, hlist)
  disp('Save Pre-Init...');
  
  // la lista contiene tutte le righe della sezione di PRE-INIT
  // (prima ed ultima escluse)
  mfprintf(fd, '// INIT-PRE-BEGIN\n');
  if size(hlist) > 0 then
    for i = 1 : size(hlist)
      mfprintf(fd, '%s\n', hlist(i));
    end
  else
    mfprintf(fd, '// ... entry point for preliminary init functions call ...\n');
  end
  mfprintf(fd, '// INIT-PRE-END\n\n');
endfunction


//////////////////////////////////////////////////////////////////////////////////////////////////

function hlist = loadPostInit (fd)
  disp('Load Post-Init...');
  
  // legge dati da file
  hlist = list();
  str = mgetl(fd, 1);
  while strindex(str, '// INIT-POST-END') ~= 1
    // aggiunge linea alla lista
    hlist($+1) = str;
    
    // legge riga successiva
    str = mgetl(fd, 1);
  end
endfunction

function savePostInit (fd, hlist)
  disp('Save Pre-Init...');
  
  // la lista contiene tutte le righe della sezione di POST-INIT
  // (prima ed ultima escluse)
  mfprintf(fd, '// INIT-POST-BEGIN\n');
  if size(hlist) > 0 then
    for i = 1 : size(hlist)
      mfprintf(fd, '%s\n', hlist(i));
    end
  else
    mfprintf(fd, '// ... entry point for post init functions call ...\n');
  end
  mfprintf(fd, '// INIT-POST-END\n\n');
endfunction


//////////////////////////////////////////////////////////////////////////////////////////////////

function hlist = loadAuxFun (fd)
  disp('Load Aux-Fun...');
  
  // legge dati da file
  hlist = list();
  str = mgetl(fd, 1);
  while strindex(str, '// AUX-FUN-END') ~= 1
    // aggiunge linea alla lista
    hlist($+1) = str;
    
    // legge riga successiva
    str = mgetl(fd, 1);
  end
endfunction

function saveAuxFun (fd, hlist)
  disp('Save Aux-Fun...');
  
  // la lista contiene tutte le righe della sezione di AUX-FUN
  // (prima ed ultima escluse)
  mfprintf(fd, '// AUX-FUN-BEGIN\n');
  if size(hlist) > 0 then
    for i = 1 : size(hlist)
      mfprintf(fd, '%s\n', hlist(i));
    end
  else
    mfprintf(fd, '// ... entry point for auxiliary functions definition ...\n');
  end
  mfprintf(fd, '// AUX-FUN-END\n\n');
endfunction


