// *** SciGui checkbox object handling
// *** by G. Casonato - Marzo 2007

function hobj = loadCheckBox(fd, hfig_wk)
  disp('Load CheckBox...');
  
  // legge dati da file
  str = mgetl(fd, 1); // uicontrol
  str = mgetl(fd, 1); // tag
  pos = strindex(str, '''tag'', ''');
  str1 = strsplit(str, pos+7);
  str2 = sscanf(str1(2), '%s');
  str3 = strsplit(str2, length(str2)-2);
  objtag = str3(1);

  str = mgetl(fd, 1); // string
  pos = strindex(str, '''string'', ''');
  str1 = strsplit(str, pos+10);
  str2 = sscanf(str1(2), '%s');
  str3 = strsplit(str2, length(str2)-2);
  objstr = str3(1);

  str = mgetl(fd, 1); // position
  pos = strindex(str, '[');
  str1 = strsplit(str, pos);
  [px, py, wd, hg] = sscanf(str1(2), '%d %d %d %d]');

  // crea oggetto
  hobj = uicontrol(hfig_wk, 'style', 'checkbox', ...
    'tag', objtag, ...
    'string', objstr, ...
    'position', [px py wd hg]);

endfunction

function saveCheckBox (fd, hobj)
  disp('Save CheckBox...');

  pos = get(hobj, 'position');
  pos = evstr(pos);
  tag = get(hobj, 'tag');
  str = get(hobj, 'string');
  mfprintf(fd, '// CHECKBOX: %s\n', str);
  mfprintf(fd, 'hobj = uicontrol(hfig, ''style'', ''checkbox'', ...\n');
  mfprintf(fd, '  ''tag'', ''%s'', ...\n', tag);
  mfprintf(fd, '  ''string'', ''%s'', ...\n', str);
  mfprintf(fd, '  ''position'', [%d %d %d %d]);\n\n', pos(1), pos(2), pos(3), pos(4)); 
//  mfprintf(fd, 'hobjs = [hobjs; hbut];\n\n');
endfunction

function hobj = editCheckBox (hmode, hfig_wk, hobj)
  disp('Edit CheckBox...');

  // hmode definisce modalit:
  // - new:  crea nuova oggetto con ID <hobj>
  // - edit: modifica oggetto esistente <hobj>

  // legge posizione/nome
  if hmode == 'edit' then
    // edit: legge valori correnti
    objpos = get(hobj, 'position');
    objstr = get(hobj, 'string');
  else
    // new: imposta valori di default
    objpos = [100 50 150 120];
    objtag = 'ListBox'+string(hobj);
    objstr = objtag;
  end  
  
  // legge posizione
  lbl = ['position (x, y): '; 'size (width, height): '];
  def = [string(objpos(1))+' '+string(objpos(2)); ...
         string(objpos(3))+' '+string(objpos(4))];
  objdata = x_mdialog('enter object data', lbl, def);
  objpos = evstr(objdata(1 : 2));

  px = objpos(1,1);
  py = objpos(1,2);
  wd = objpos(2,1);
  hg = objpos(2,2);

  if hmode == 'edit' then
    // edit: modifica parametri oggetto   
    set(hobj, 'position', [px py wd hg]);
  else
    // new: aggiunge oggetto nella posizione specificata
    hobj = uicontrol(hfig_wk, 'style', 'checkbox', ...
      'tag', string(objtag), ...
      'string', string(objstr), ...
      'position', [px py wd hg]);
  end
endfunction


